#pragma once
#include <list>
#include "ChatUser.h"
#include "ChatItem.h"
#include <ftlSharePtr.h>
#include <ftlThread.h>
#include "TranslateFileInfo.h"

typedef struct CHAT_MSG
{
	CString strID;
	CString strName;
	CString strNickName;
	int time;
	CString pszMsg;
	CHARFORMAT2 cf;
	UINT nMsgSeq;
	UINT nTid;
	BYTE msgType;
	
	CHAT_MSG()
	{
		strID = _T("");
		strName = _T("");
		strNickName = _T("");
		time = 0;
		pszMsg = _T("");
        ZeroMemory(&cf, sizeof(cf));    //lint !e1415
		nMsgSeq = 0;
		nTid = 0;
		msgType = 1;
	}
}CHAT_MSG;

typedef struct 
{
	UINT nTid;
	CString strMessage;
	CTime	tmTime;
}CHAT_MYMSG;

typedef enum
{
	MAKETYPE_CREATE,		//   
	MAKETYPE_INVITE,		// ʴǾ ϴ 
	MAKETYPE_JOIN,			// ٽ ϴ 
	MAKETYPE_FORCEJOIN,
	MAKETYPE_FORCEJOINED
}EChatMakeType;

typedef enum
{
	SESSION_ERROR,
	SESSION_UNINITIALIZED,
	SESSION_ONGOING,	
	SESSION_SUCCESS,
}ESession;

typedef enum
{
	REASON_NONE,
	REASON_CREATE,
	REASON_SESSION_RECOVERY,
	REASON_NETWORK_RECOVERY
}ESessionReason;

typedef enum
{
	INITROOM_ERROR,
	INITROON_UNINITIALIZED,
	INITROOM_ONGOING,
	INITROOM_SUCCESS,
	INITROOM_FORCELEAVE,
}EInitRoom;

typedef enum
{
	REGISTER_ERROR,
	REGISTER_UNINITIALIZED,
	REGISTER_ONGOING, 
	REGISTER_SUCCESS,
}EInviteList;


#define USERLIST_EMPTY		(-1)
#define USERLIST_NOTFOUND	(-2)

#define ACK_DIFFTIME		(4)


class CChatModel
{
public:
	CChatModel(void);
	~CChatModel(void);

	int					GetUserCount();
	void				SetChatRoomMakeType(EChatMakeType eMakeType) { m_eChatMakeType = eMakeType; }
	EChatMakeType		GetChatRoomMakeType() { return m_eChatMakeType; }

	void				SetServerInfo(LPCTSTR strSrvAddress, int nSrvPort, int nRoomID, LPCTSTR strRoomType);
	CString				GetSrvAddress() { return m_strChatSrvAddress; }
	int					GetSrvPort() { return m_nChatSrvPort; }
	int					GetRoomID() { return m_nRoomID; }
	bool				IsValidServerInfo();

	//void				SetChatRoomSequeceNumber(int nSeqNumber) { m_nChatRoomSequecenNumber = nSeqNumber; }	
	trid_t				GetChatTrid();
	void				SetChatInfo(int nSeqNumber, const vector<CChatUser*>& userList, EChatMakeType enumMakeType);
	int					GetOfflineUserCount();
	void				SetInviteUserName(LPCTSTR strInviteUser) { m_strInviteUserName = strInviteUser; }
	CString				GetInviteUserName() { return m_strInviteUserName; }
	
	void				SetRecvChatViewDefaultFont(CHARFORMAT2* pcfDefault);
	void				SetSendChatViewUserFont(CHARFORMAT2* pcfUser);

	/* ˾ ˸ ޼*/

	void				SetPopupMessage(LPCTSTR strNickName, LPCTSTR strMsg , int nMsgType);
	LPCTSTR				GetPopupMessage() { return (LPCTSTR)m_strPopupMessage; }

	void                SetTrayPopupInfo(LPCTSTR strID, LPCTSTR strNickName, LPCTSTR strMsg , int nMsgType);
    TRAYPOPINFO         GetTrayPopupInfo() { return m_trayPopInfo; }
	void				InitInviteUserStatus();
	void				SetInviteUserStatus(LPCTSTR strID, BOOL bInviteStatus);
	void				SetInviteUserStatus(vector<LPCTSTR> vecID, BOOL bInviteStatus);
	
	BOOL				ChangeNickName(LPCTSTR strID, LPCTSTR strNickName);

	/*   */
	void				SetMyUserData(GT_MY_USER_DATA* pstMyUserData);
	CString				GetMyID() { return CString(m_stMyData.strUserID); }  //64(lint)
	CString				GetMyName() { return CString(m_stMyData.sMyPage.strUserName); }
	CString				GetMyTalkName() { return CString(m_stMyData.sMyPage.strTalkName); }
	GTUserStatusType	GetMyStatus() { return m_stMyData.eUserStatusType; }
	GT_MYPAGE_DATA		GetMyPage() { return m_stMyData.sMyPage; }

	/* ä   */
	void				AddChatUser(CChatUser* pUser);
	void				AddChatUser(LPCTSTR strUserID, LPCTSTR strUserName, LPCTSTR strUserNickName, GTUserStatusType status, BOOL bInviteStatus);
	int					FindUserMap(LPCTSTR strUserID);	// (strUserID)  ߿ ִ ã´
	void                GetChatUserArray(std::vector<CChatUser*> &chatUsrArray);

	CChatUser*          GetChatUsrPtr(LPCTSTR strID);
	CString				GetChatUserName(LPCTSTR strID);
	static int __cdecl        ItemComareFunc(void *pvlocale,const void *elem1, const void *elem2);
	
	CString				GetChatUserNickName(LPCTSTR strID);
	CString				GetChatUserExtensionTel(LPCTSTR strID);
	CString				GetChatUserCellphone(LPCTSTR strID);
	CString				GetChatUserJobPos(LPCTSTR strID);
	CString				GetChatUserJobDuty(LPCTSTR strID);
	CString				GetChatUserDeptName(LPCTSTR strID);
	void				RefreshTalkName();
	void				SetChatUserStatus(LPCTSTR strID, GTUserStatusType status);
	void				SetAllChatUserOffline();
	void				SetChatUserIptStatus(LPCTSTR strID, NTIPTStatusType iptStatus);
	GTUserStatusType	GetChatUserStatus(LPCTSTR strID);
	NTIPTStatusType		GetChatUserIptStatus(LPCTSTR strID);
	int					GetChatUserMapCount() { return m_mapUserList.size(); }	//  Ե  ȭ ̴.
	CString				GetChatUserID(int idx);
	void				SetTalkNameList(vector<NT_TALKNAME_DATA> vecTalkName);	
	BOOL				SetChatUserInfo(const NE_MEMBER_DATA* userData);
	BOOL				IsUserInfoLoaded(LPCTSTR strID);
	vector<LPCTSTR>		GetNotJoinUserList();

	CString				GetOfflineUser();
	int					GetOnlineUserCount();
	BOOL				IsOfflineUser(LPCTSTR strUserID);
	CString				GetAllUserId();
	CString				GetAllUserName();	// ȭ  Ʈ(ڽ )

	/* ä ޼  */	
	void				AddChatMessage(CHAT_MSG* pMsg) { m_arChatMessage.Add((CObject*)pMsg); }
	void				AddChatMessage(LPCTSTR strID, LPCTSTR strName, LPCTSTR strNickName, int time, LPCTSTR strMsg, CHARFORMAT2* pFont, UINT nMsgSeq, UINT nTid, BYTE msgType);
	BOOL				IsAlreadyExistChatTid(LPCTSTR strID, UINT nTid);
	void				AddChatMessageTid(LPCTSTR strID, UINT nTid);
	void				ResetTid(LPCTSTR strID);
	void				AddMyMessageTid(UINT nTid, LPCTSTR strMessage, CTime tmSend);
	void				AddMyTranslateTid(UINT nTid, TranslateFileInfoPtr& pTranslateFileInfo);
	void				AddMyTranslateFileInfo(LONG nJobIndex, TranslateFileInfoPtr& pTranslateFileInfo);
    void                SetMyMessageTidSendTime(UINT nTid);
	void				ResetMyMessageTid();
	void				ResetMyTranslateTid();
	void				ResetMyTranslateFileInfo();
	bool				AckMyMessageTid(UINT nTid);
	bool				AckMyTranslateTid(UINT nTid);
	TranslateFileInfoPtr		GetMyTranslateFileInfo(LONG nJobIndex, BOOL bRemove);
	//void				AddRetryTranslateFileInfo(TranslateFileInfoPtr& pTranslateFileInfo);
	//TranslateFileInfoPtr		GetRetryTranslateFileInfo();
	void				CheckSendMsgAck(vector<CHAT_MYMSG*>& rvec);
	void				CheckSendFileMsgAck(vector<TranslateFileInfoPtr>& rvec);
	
	void				SetGroupRoom(BOOL bGroupRoom) { m_bGroupRoom = bGroupRoom; }
	BOOL				IsGroupRoom() { return m_bGroupRoom; }	
	
	BOOL				IsInvitedUser(LPCTSTR strID);
	
	bool				IsExistChatMessage();
	CHAT_MSG*			GetFrontChatMessage();
	void				RemoveFrontChatMessage();
	void				RemoveAllChatMessage();
	CHARFORMAT2			GetSendChatViewUserFont() { return m_cfUserSendChatView; }
	CHARFORMAT2			GetDefaultChatFont() { return m_cfDefaultRecvChatView; }

	/* ä (ȭâ ǥ ֱ    ) */
	int					AddChatItemToArray(CChatItem* pChatItem);
	CPtrArray*			GetChatItemArray()	{ return &m_ptrArChatItem; }	// ߽/  ȭ ϰ ִ 迭
	int					GetChatItemCount()	{ return m_ptrArChatItem.GetCount(); }
	int					GetChatItemIndex(const CString &strUserId,int nTid);
	CChatItem*			GetChatItem(int nIndex) { return (CChatItem*)m_ptrArChatItem.GetAt(nIndex); }
	BOOL				IsExistChatUserItem();
	void				SetMsgSequence(CString strUserID, UINT nTid, UINT nMsgSeq);
	void				IncreaseFailCount(CString strUserId,UINT nTid);
	void				ClearChatItemAll();
	BOOL				RemoveChatItem(int nIndex,BOOL bDelete = TRUE);

	/* Ÿ */
	BOOL				IsOldRoomType();
	void				SetRoomType(LPCTSTR strRoomType);
	UINT				GetChatMsgTid();
	void				SetChatMsgTid(UINT tid);

	BOOL				RemoveChatUserMap(BOOL bAll = TRUE, LPCTSTR strID = NULL);

	void                ClearInputActionUsers(){m_mapTypingActionUser.clear();}
	BOOL                IsInputActionUsersEmpty(){return (!!m_mapTypingActionUser.empty()); }
    BOOL                CheckInputActionUserTimeOut(DWORD dwMaxTimeOut);
	void				AddInputActionUser(LPCTSTR strUserName);
	void				DelInputActionUser(LPCTSTR strUserName);
	CString				GetInputActionUserString();
	BOOL				IsEqualChatDlg(const std::vector<CChatUser *>& userList, LPCTSTR strAddress, int nPort, int nRoomID);

	ESession			GetSessionCreateStatus() { return m_eSessionCreate; }
	void				SetSessionCreateStatus(ESession status) { m_eSessionCreate = status; }
	BOOL				CheckSessionCreateStatus(ESession status);
	EInitRoom			GetInitRoomStatus() { return m_eInitRoom; }
	void				SetInitRoomStatus(EInitRoom status) { m_eInitRoom = status; }
	BOOL				CheckinitRoomStatus(EInitRoom status);
	EInviteList			GetInviteListStatus() { return m_eInviteList; }
	void				SetInviteListStatus(EInviteList status) { m_eInviteList = status; }
	BOOL				CheckInviteListStatus(EInviteList status);
	ESessionReason		GetSessionReason() { return m_eSessionReason; }
	void				SetSessionReason(ESessionReason reason) { m_eSessionReason = reason; }
	BOOL				CheckSessionReason(ESessionReason reason);
	int					GetCreateSessionCheckTimes() { return m_nCreateSessionCheckTimes; }
	void				IncreaseCreateSessionCheckTimes() { m_nCreateSessionCheckTimes++; }
	void				ResetCreateSessionCheckTimes() { m_nCreateSessionCheckTimes = 0; }
	void				SetChatUsers(const vector<CChatUser*>& userList);	

	void				AddMsgSequence(UINT nMsgSeq);
	bool				IsAlreadyExistMsgSequence(UINT nMsgSeq);
	UINT				GetMsgCount(); 
	CCriticalSection*	GetChatItemCS() { return &m_csChatItem; }
	void				AddRecentChatItemToArray( CChatItem* pChatItem );
	void				UpdateMsgStatus(CString strUserId,UINT nTid, int status);
	void				UpdateAllChatItemUserStatus(CString strUserId,GTUserStatusType status);
	BOOL				IsHaveMessageRecord();

	vector<CChatUser*> GetSortedChatUserVector();
	void SortChatUserVector();

	void				CancelTransferFile(vector<TranslateFileInfoPtr>& rvec);

private:
	BOOL						m_bHaveMsgRecord;
	EChatMakeType				m_eChatMakeType;			// ä  (ȭ , ʴ븦 ޾Ҵ, Ͽ ȭ̾ 濡 ̾ Ѵ.)
	int							m_nChatRoomSequecenNumber;	//  äâ ȣ
	map<CString, CChatUser*>	m_mapUserList;				//  ä  ( ڽ  ʴ´)
	map<CString, CString>		m_mapTalkNameList;			// ȭ Ʈ
	vector<CChatUser*>		     m_vectorChatUsr;
	int							m_nRoomID;					//    ̵
	CString						m_strChatSrvAddress;		//  äü ּ
	CString						m_strRoomType;				// 1:1 ȭ 翬
	int							m_nChatSrvPort;				//  äü Ʈ
	BOOL						m_bGroupRoom;				// ׷ äù
	CString						m_strInviteUserName;		//  ʴ 
	GT_MY_USER_DATA				m_stMyData;					//  ޽ α 
	CObArray					m_arChatMessage;			// ä ޼ ť(ó ޽ )
	CPtrArray					m_ptrArChatItem;			// /߽  ȭ  ִ 迭( )
	CHARFORMAT2					m_cfDefaultRecvChatView;	// äâ  ޼  ⺻ Ʈ
	CHARFORMAT2					m_cfUserSendChatView;		// äâ  ޼  ڼ Ʈ
	CString						m_strPopupMessage;			// äôȭû  ˸  ޼	
	UINT						m_nMsgTid;					//   ޽ tid sequence (1 )
	map< UINT, CHAT_MYMSG* >	m_mapMyTid;					//   ޼ tid list

	CString						m_strPopupMessageName;
	CString						m_strPopupMessageMsg;

	FTL::CFCriticalSection		m_lockMapFileTid;
	map< UINT, TranslateFileInfoPtr>	m_mapMyFileTid;		// Tid -> Transfer file info
	FTL::CFCriticalSection		m_lockMapTranslateFileJobs;
	typedef map< LONG, TranslateFileInfoPtr>	MyTranslateFileJobContainer;
	MyTranslateFileJobContainer		m_mapMyTranslateFileJobs;
	FTL::CFCriticalSection		m_lockRetryTranslateFileJobs;
	std::list<TranslateFileInfoPtr>	m_lstRetryTranslateFileInfo;

	list<UINT>					m_listMsgSeq;				// ȭ MsgSeq ( ִ )
	list<UINT>					m_listFileSeq;
	map< CString, list<UINT> >	m_mapChatUserTid;			// ڵ ȭ tid ( ȭ ߺǴ  ϱ )
    typedef  map< CString, DWORD>   TypingActionUserContainer;
	TypingActionUserContainer	    m_mapTypingActionUser;		//  Է ϰ ִ   Ʈ	
    CString                     m_strLastTypingActionUser;

	CCriticalSection			m_csMapUserList;
    CCriticalSection			m_csTalkNameList;
	ESession					m_eSessionCreate;			// ä   
	EInitRoom					m_eInitRoom;				// äù  Ϸ 
	EInviteList					m_eInviteList;				// ʴ븮Ʈ Ϸ 
	ESessionReason				m_eSessionReason;			// ǻ  
	int							m_nCreateSessionCheckTimes;	// ǻ üũ Ƚ

	CCriticalSection	        m_csChatItem;
    TRAYPOPINFO                 m_trayPopInfo;
};
